Compare commits

...

54 Commits

Author SHA1 Message Date
mudler c8cd58df4b [builder, sabayon-buildpackages] add QA_CHECKS env variable 2016-07-08 00:28:18 +02:00
Ettore Di Giacinto 44d7510792 [builder] removing append to make.conf, now the env variable is set and working also on the entropy side 2016-07-03 14:48:44 +02:00
Ettore Di Giacinto c7891958ea [functions] add --noreplace to default args 2016-05-28 12:56:52 +02:00
mudler c8a1ece37c [functions] build() and build_installed() echoing packages being installed 2016-05-28 12:33:09 +02:00
Ettore Di Giacinto fb745c8ed8 [builder] use ACCEPT_LICENSE with wildcard since Entropy 302 2016-05-26 12:17:07 +02:00
mudler 36fc5a6656 [sabayon-buildpackages] adding support for REMOVE_REMOTE_OVERLAY REMOVE_LAYMAN_OVERLAY 2016-05-17 19:31:52 +02:00
mudler a65f1acdca [builder] add support for REMOVE_REMOTE_OVERLAY and REMOVE_LAYMAN_OVERLAY 2016-05-17 19:30:40 +02:00
mudler 02fd49a321 [builder] better output for logs 2016-05-17 19:23:27 +02:00
mudler 868dfb767d [builder] clone user defined local_portage only if dir exists 2016-05-17 19:20:20 +02:00
mudler 5855d12d75 [builder] allow to pass to remote overlay the name and the sync-type 2016-05-17 19:18:24 +02:00
mudler 44aa54b031 [builder] removing dots from repository name 2016-05-16 11:12:02 +02:00
mudler 6bcf4abfee [builder] changing namespace allocation 2016-05-16 00:18:34 +02:00
mudler 31d3bca34b [builder] guessing sync_type from url 2016-05-13 22:45:30 +02:00
mudler 869f6a4363 [builder] url must be given in absolute form 2016-05-13 22:12:21 +02:00
mudler 3709d50006 [builder] default masters = gentoo https://github.com/Sabayon/community-buildspec/issues/9 2016-05-13 21:59:05 +02:00
mudler 939acad797 [builder] fixes and enhancement to add_portage_repository() https://github.com/Sabayon/community-buildspec/issues/9 2016-05-13 21:56:09 +02:00
mudler d9042cc4b5 [sabayon-buildpackages] TEMPDIR now is useless https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:16:30 +02:00
mudler 64d7085cb6 [builder/sabayon-buildpackages] passing REMOTE_OVERLAY to builder and adding repos as listed https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:09:44 +02:00
mudler 795aab5d24 [builder] don't re-add the repository if already there, sync instead. name of overlay now will be in the form namespace-name https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 12:04:34 +02:00
mudler b57f8905fe [builder] adding add_portage_repository() https://github.com/Sabayon/community-buildspec/issues/9 2016-05-12 11:58:14 +02:00
mudler 93a1093560 [builder] set ETP_NONINTERACTIVE to 1 2016-05-11 10:43:30 +02:00
mudler 84e62c332b [builder/buildpackages] adding EMERGE_REMOVE env 2016-05-10 11:40:08 +02:00
mudler 4430495086 [builder] printing what package we are compiling 2016-05-09 10:25:02 +02:00
mudler 70a7542692 [builder] remove workaround no longer needed 2016-05-03 23:55:27 +02:00
Ettore Di Giacinto 8aed3a00fa [builder] ENMAN_ADD_SELF defaults to 0 2016-05-03 10:47:29 +02:00
mudler 35f27e7b3b [builder/buildpackages] adding REMOVE_ENMAN_REPOSITORIES 2016-05-02 14:11:50 +02:00
Ettore Di Giacinto 6b1d8377b6 Update README.md 2016-04-30 14:33:34 +02:00
mudler db91098e92 [sabayon-createrepo-*] fixup typo 2016-04-22 17:42:35 +02:00
mudler 6fcccf99b8 [builder] do not check if string is contained in append_to_file if doesn't exists 2016-04-22 11:13:34 +02:00
mudler 67781838d3 [builder/sabayon-buildpackages] safe copy /usr/local/portage 2016-04-21 22:01:22 +02:00
mudler 69d8e28ac1 [builder] fixing permissions on local overlay 2016-04-21 21:52:41 +02:00
mudler b491ffccae [builder] check if the content is already there before appending content to file 2016-04-21 21:30:09 +02:00
mudler 066fb07d72 [builder] typo fixes 2016-04-17 19:47:01 +02:00
mudler c89721ab2e [builder] dropping equo (un)mask call, writing directly to packages.(un)mask files 2016-04-16 16:20:28 +02:00
mudler ea3d87a48a [sabayon-createrepo-*] adding gpg key support 2016-04-14 23:28:25 +02:00
mudler d1481e915f [builder] equo (s)mask should be done before installing any packages 2016-04-13 16:08:36 +02:00
mudler b185a1536b [sabayon-buildpackages] typo fix 2016-04-11 21:35:19 +02:00
mudler b089771d17 [builder/sabayon-buildpackages] adding support for equo (un)mask 2016-04-11 21:27:33 +02:00
mudler f81e90d555 [builder] don't exit if no args are given, allowing creating up-to-dated container with all set-up for compilation also if no args are given. adding --help 2016-04-08 19:20:20 +02:00
mudler fb930cdeb3 [builder] add support for BUILD_INJECTED_ARGS 2016-04-08 19:09:06 +02:00
mudler a904bbcbe1 [sabayon-createrepo] adding information output of repo creation phases 2016-04-08 00:51:08 +02:00
mudler ccd4a760f4 [sabayon-createrepo] fixing eit key signing 2016-04-08 00:47:59 +02:00
mudler 0944d27ce9 [sabayon-createrepo] fixing typo 2016-04-08 00:17:42 +02:00
mudler d248206aaa [sabayon-createrepo] push after repository initialization 2016-04-07 22:11:55 +02:00
mudler 65c62a3d8a [sabayon-*] executables 2016-04-07 21:06:13 +02:00
mudler 3be8ff13d1 [sabayon-help-info] adding script to collect system information to allow easy sharing for assistance 2016-04-07 21:05:59 +02:00
mudler 99cae9c7d1 [sabayon-createrepo] don't import keys if already exists 2016-04-07 16:09:09 +02:00
mudler d0df62c8f6 [sabayon-createrepo] signing old packages before injecting new ones 2016-04-06 21:48:28 +02:00
mudler 6ee7ef7845 [builder] show in logs the devkit version 2016-03-29 19:07:48 +02:00
mudler b212b4ce8b [sabayon-buildpackages builder] support for REPOSITORY_NAME and ENMAN_ADD_SELF 2016-03-29 18:58:46 +02:00
mudler c7fce5fd62 [builder] adding revdep-rebuild in preserved_rebuild phase. if an user enables it, it is sane to call also revdep-rebuild 2016-03-29 18:23:20 +02:00
mudler 330eb6faef [builder] adding notes on why we do safe_call during equo install phases 2016-03-29 12:18:07 +02:00
mudler 1e993271ec [builder] code cleanup 2016-03-29 12:07:50 +02:00
mudler 4a1e3e1f41 [builder] use safe_call for system calls that are vital. If they don't succeds they will bail out the build 2016-03-29 12:07:37 +02:00
11 changed files with 286 additions and 114 deletions
+3 -1
View File
@@ -11,7 +11,7 @@ sudo equo i sabayon-devkit
## Prerequisites ## Prerequisites
* docker installed in the machine (`sudo equo i docker`), and the daemon started (`sudo systemctl start docker`) * docker installed in the machine (`sudo equo i docker`), and the daemon started (`sudo systemctl start docker`)
* if you don't want to run that as root, the user where are you running the script must be in the docker group (`sudo gpasswd -a $USER docker`) * if you don't want to run that as root, the user where are you running the script must be in the docker group (`sudo gpasswd -a $USER docker`), or granting permission to yourself adding your user to the sudoer file.
Packages can be built in a clean environment with docker by running `sabayon-buildpackages`. Packages can be built in a clean environment with docker by running `sabayon-buildpackages`.
@@ -92,6 +92,8 @@ you can override the Architecture folder in which files are placed specifying in
- DOCKER_PULL_IMAGE -- tells the script to update the docker image before compiling, enable it with 1, disable with 0 - DOCKER_PULL_IMAGE -- tells the script to update the docker image before compiling, enable it with 1, disable with 0
- OUTPUT_DIR -- optional, default to "portage_artifacts" in your current working directory, it is the path where emerge generated tbz2 are stored (absolute path) - OUTPUT_DIR -- optional, default to "portage_artifacts" in your current working directory, it is the path where emerge generated tbz2 are stored (absolute path)
- LOCAL_OVERLAY -- optional, you can specify the path to your local overlay (absolute path) - LOCAL_OVERLAY -- optional, you can specify the path to your local overlay (absolute path)
- REMOTE_OVERLAY -- optional, a space separated list of overlays that can be cloned with git.
The arguments are the packages that you want compile, they can be also in the complete form *e.g. =foo-bar/misc-1.2* The arguments are the packages that you want compile, they can be also in the complete form *e.g. =foo-bar/misc-1.2*
+211 -60
View File
@@ -17,54 +17,133 @@ my $equo_install_atoms = $ENV{EQUO_INSTALL_ATOMS} // 1;
my $equo_install_version = $ENV{EQUO_INSTALL_VERSION} // 0; my $equo_install_version = $ENV{EQUO_INSTALL_VERSION} // 0;
my $equo_split_install = $ENV{EQUO_SPLIT_INSTALL} // 0; my $equo_split_install = $ENV{EQUO_SPLIT_INSTALL} // 0;
my $equo_mirrorsort = $ENV{EQUO_MIRRORSORT} // 1; my $equo_mirrorsort = $ENV{EQUO_MIRRORSORT} // 1;
my $entropy_repository = $ENV{ENTROPY_REPOSITORY} // "main"; # Can be weekly, main, testing my $entropy_repository = $ENV{ENTROPY_REPOSITORY}
// "main"; # Can be weekly, main, testing
my $artifacts_folder = $ENV{ARTIFACTS_DIR}; my $artifacts_folder = $ENV{ARTIFACTS_DIR};
my $dep_scan_depth = $ENV{DEPENDENCY_SCAN_DEPTH} // 2; my $dep_scan_depth = $ENV{DEPENDENCY_SCAN_DEPTH} // 2;
my $skip_portage_sync = $ENV{SKIP_PORTAGE_SYNC} // 0; my $skip_portage_sync = $ENV{SKIP_PORTAGE_SYNC} // 0;
my $emerge_split_install = $ENV{EMERGE_SPLIT_INSTALL} // 0; my $emerge_split_install = $ENV{EMERGE_SPLIT_INSTALL} // 0;
my $webrsync = $ENV{WEBRSYNC} // 0; my $webrsync = $ENV{WEBRSYNC} // 0;
my $enman_repositories = $ENV{ENMAN_REPOSITORIES}; my $enman_repositories = $ENV{ENMAN_REPOSITORIES};
my $emerge_remove = $ENV{EMERGE_REMOVE};
my $remove_enman_repositories = $ENV{REMOVE_ENMAN_REPOSITORIES};
my $remove_remote_overlay = $ENV{REMOVE_REMOTE_OVERLAY};
my $remove_layman_overlay = $ENV{REMOVE_LAYMAN_OVERLAY};
my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0; my $prune_virtuals = $ENV{PRUNE_VIRTUALS} // 0;
my $repository_name = $ENV{REPOSITORY_NAME};
my $enman_add_self = $ENV{ENMAN_ADD_SELF} // 0;
my $build_injected_args = $ENV{BUILD_INJECTED_ARGS};
my $equo_masks = $ENV{EQUO_MASKS};
my $equo_unmasks = $ENV{EQUO_UNMASKS};
my $remote_overlay = $ENV{REMOTE_OVERLAY};
my $repoman_check = $ENV{QA_CHECKS} // 0;
my $make_conf = $ENV{MAKE_CONF}; my $make_conf = $ENV{MAKE_CONF};
my @overlays; my @overlays;
my $help = 0;
GetOptions(
'layman|overlay:s{,}' => \@overlays,
'equo|install:s{,}' => \@equo_install,
'equorm|remove:s{,}' => \@equo_remove,
'help|?' => \$help
);
GetOptions( 'layman|overlay:s{,}' => \@overlays, 'equo|install:s{,}' => \@equo_install,'equorm|remove:s{,}' => \@equo_remove ); help() if $help;
if ( @ARGV == 0 ) {
help();
die();
}
$ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons $ENV{LC_ALL} = "en_US.UTF-8"; #here be dragons
$ENV{ETP_NONINTERACTIVE} = 1;
$ENV{ACCEPT_LICENSE} = "*"; # we can use wildcard since entropy 302
# A barely print replacement # A barely print replacement
sub say { print join( "\n", @_ ) . "\n"; } sub say { print join( "\n", @_ ) . "\n"; }
sub safe_call {
my $cmd = shift;
my $rt = system($cmd);
my $return = $rt >> 8;
exit($return) if ($rt);
}
sub append_to_file {
my ( $file_name, $package ) = @_;
if ( -f $file_name ) {
# Check that the package was not already there
open my $fh_ro, '<:encoding(UTF-8)', $file_name
or die("Cannot open: $file_name");
while ( my $line = <$fh_ro> ) {
return if $line eq $package . "\n";
}
close $fh_ro;
}
open( my $fh_a, '>>', $file_name )
or die "Could not open file '$filename' $!";
print $fh_a $package . "\n";
close $fh_a;
}
sub add_portage_repository {
my $repo = $_[0];
my $reponame;
my $sync_type;
my @repodef = split( /\|/, $repo );
( $reponame, $repo ) = @repodef if ( @repodef == 2 );
( $reponame, $sync_type, $repo ) = @repodef if ( @repodef == 3 );
# try to detect sync-type
if ( !$sync_type ) {
$sync_type = ( split( /\:/, $repo ) )[0];
$sync_type = "git"
if $repo =~ /github|bitbucket/
or $sync_type eq "https"
or $sync_type eq "http";
$sync_type = "svn" if $repo =~ /\/svn\//;
}
$reponame = ( split( /\//, $repo ) )[-1] if !$reponame;
$reponame =~ s/\.|//g; #clean
system("mkdir -p /etc/portage/repos.conf/")
if ( !-d "/etc/portage/repos.conf/" );
say "==== Adding $reponame ====";
qx{
echo '[$reponame]
location = /usr/local/overlay/$reponame
sync-type = $sync_type
sync-uri = $repo
auto-sync = yes' > /etc/portage/repos.conf/$reponame.conf
}; # Declaring the repo and giving priority
system("emaint sync -r $reponame");
}
# Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output) # Input: package, depth, and atom. Package: sys-fs/foobarfs, Depth: 1 (depth of the package tree) , Atom: 1/0 (enable disable atom output)
sub package_deps { sub package_deps {
my $package = shift; my $package = shift;
my $depth = shift // 1; # defaults to 1 level of depthness of the tree my $depth = shift // 1; # defaults to 1 level of depthness of the tree
my $atom = shift // 0; my $atom = shift // 0;
# Since we expect this sub to be called multiple times with the same arguments, cache the results # Since we expect this sub to be called multiple times with the same arguments, cache the results
state %cache; state %cache;
$cache_key = "${package}:${depth}:${atom}"; $cache_key = "${package}:${depth}:${atom}";
if ( ! exists $cache{$cache_key} ) { if ( !exists $cache{$cache_key} ) {
@dependencies = qx/equery -C -q g --depth=$depth $package/; #depth=0 it's all @dependencies =
qx/equery -C -q g --depth=$depth $package/; #depth=0 it's all
chomp @dependencies; chomp @dependencies;
# If an unversioned atom is given, equery returns results for all versions in the portage tree # If an unversioned atom is given, equery returns results for all versions in the portage tree
# leading to duplicates. The sanest thing to do is dedup the list. This gives the superset of all # leading to duplicates. The sanest thing to do is dedup the list. This gives the superset of all
# possible dependencies, which isn't perfectly accurate but should be good enough. For completely # possible dependencies, which isn't perfectly accurate but should be good enough. For completely
# accurate results, pass in a versioned atom. # accurate results, pass in a versioned atom.
@dependencies = uniq( @dependencies = uniq(
sort sort
grep { $_ } grep { $_ }
map { $_ =~ s/\[.*\]|\s//g; &atom($_) if $atom; $_ } map { $_ =~ s/\[.*\]|\s//g; &atom($_) if $atom; $_ }
@dependencies); @dependencies
);
$cache{$cache_key} = \@dependencies; $cache{$cache_key} = \@dependencies;
} }
@@ -88,8 +167,8 @@ sub available_packages {
sub calculate_missing { sub calculate_missing {
my $package = shift; my $package = shift;
my $depth = shift; my $depth = shift;
my @Installed_Packages = @{+shift}; my @Installed_Packages = @{ +shift };
my @Available_Packages = @{+shift}; my @Available_Packages = @{ +shift };
my $prune_virtuals = shift; my $prune_virtuals = shift;
# Getting the package dependencies and the installed packages # Getting the package dependencies and the installed packages
@@ -98,11 +177,13 @@ sub calculate_missing {
if ($prune_virtuals) { if ($prune_virtuals) {
say "[$package] Pruning dependencies of virtual packages"; say "[$package] Pruning dependencies of virtual packages";
my %install_dependencies = map { $_ => 1 } @dependencies; my %install_dependencies = map { $_ => 1 } @dependencies;
# Look for any virtuals and remove its immediate dependencies to avoid # Look for any virtuals and remove its immediate dependencies to avoid
# installing multiple conflicting packages one by one # installing multiple conflicting packages one by one
my @virtual_deps; my @virtual_deps;
for my $dep (@dependencies) { for my $dep (@dependencies) {
push(@virtual_deps, package_deps( $dep, 1, 1 )) if ( $dep =~ /^virtual\// ); push( @virtual_deps, package_deps( $dep, 1, 1 ) )
if ( $dep =~ /^virtual\// );
} }
for my $dep (@virtual_deps) { for my $dep (@virtual_deps) {
$install_dependencies{$dep} = 0 if ( $dep !~ /^virtual\// ); $install_dependencies{$dep} = 0 if ( $dep !~ /^virtual\// );
@@ -118,8 +199,9 @@ sub calculate_missing {
# removing from packages the one that are already installed and keeping only the available in the entropy repositories # removing from packages the one that are already installed and keeping only the available in the entropy repositories
my @to_install = grep( defined $available_packs{$_}, my @to_install = grep( defined $available_packs{$_},
uniq( grep( !defined $installed_packs{$_}, @dependencies ) ) ); uniq( grep( !defined $installed_packs{$_}, @dependencies ) ) );
@to_install=grep { length } @to_install; @to_install = grep { length } @to_install;
say "[$package] packages that will be installed with equo: @to_install" if @to_install>0; say "[$package] packages that will be installed with equo: @to_install"
if @to_install > 0;
return @to_install; return @to_install;
} }
@@ -137,15 +219,15 @@ sub uniq {
sub help { sub help {
say "-> You should feed me with something", "", "Examples:", "", say "-> You should feed me with something", "", "Examples:", "",
"\t$0 app-text/tree", "\t$0 plasma-meta --layman kde", "", "\t$0 app-text/tree", "\t$0 plasma-meta --layman kde", "",
"\t$0 app-foo/foobar --equo foo-misc/foobar --equo net-foo/foobar --layman foo --layman bar foo", "\t$0 app-foo/foobar --equo foo-misc/foobar --equo net-foo/foobar --layman foo --layman bar foo",
"**************************", "", "**************************", "",
"You can supply multiple overlays as well: $0 plasma-meta --layman kde plab", "You can supply multiple overlays as well: $0 plasma-meta --layman kde plab",
"The documentation is available at https://github.com/Sabayon/devkit", "The documentation is available at https://github.com/Sabayon/devkit",
""; "";
exit 0;
} }
say say "****************************************************";
"****************************************************";
if ( @overlays > 0 ) { if ( @overlays > 0 ) {
say "Overlay(s) to add"; say "Overlay(s) to add";
@@ -162,26 +244,21 @@ say "[*] Syncing configurations files, Layman and Portage";
# Syncronizing portage configuration and adding overlays # Syncronizing portage configuration and adding overlays
system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that. system("echo 'en_US.UTF-8 UTF-8' > /etc/locale.gen"); #be sure about that.
system( system("cd /etc/portage/;git checkout master; git stash; git pull");
"cd /etc/portage/;git checkout master; git stash; git pull"
);
if (`uname -m` eq "x86_64\n"){
system(
"cd /etc/portage/;rm -rfv make.conf;ln -s make.conf.amd64 make.conf"
);
}
system("echo 'y' | layman -f -a $_") for @overlays; system("echo 'y' | layman -f -a $_") for @overlays;
my $reponame = "LocalOverlay"; my $reponame = "LocalOverlay";
# Setting up a local overlay if doesn't exists # Setting up a local overlay if doesn't exists
system(
"rm -rf /usr/local/portage;cp -rf /usr/local/local_portage /usr/local/portage"
) if ( -d "/usr/local/local_portage" );
if ( !-f "/usr/local/portage/profiles/repo_name" ) { if ( !-f "/usr/local/portage/profiles/repo_name" ) {
system("mkdir -p /usr/local/portage/{metadata,profiles}"); system("mkdir -p /usr/local/portage/{metadata,profiles}");
system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name"); system("echo 'LocalOverlay' > /usr/local/portage/profiles/repo_name");
system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf"); system("echo 'masters = gentoo' > /usr/local/portage/metadata/layout.conf");
system("chown -R portage:portage /usr/local/portage");
} }
else { else {
open FILE, "</usr/local/portage/profiles/repo_name"; open FILE, "</usr/local/portage/profiles/repo_name";
@@ -190,6 +267,8 @@ else {
chomp(@FILE); chomp(@FILE);
$reponame = $FILE[0]; $reponame = $FILE[0];
} }
system("chown -R portage:portage /usr/local/portage");
system("chmod -R 755 /usr/local/portage");
qx{ qx{
echo '[$reponame] echo '[$reponame]
@@ -199,48 +278,92 @@ priority=9999
auto-sync = no' > /etc/portage/repos.conf/local.conf auto-sync = no' > /etc/portage/repos.conf/local.conf
}; # Declaring the repo and giving priority }; # Declaring the repo and giving priority
if ( $remote_overlay and $remote_overlay ne "" ) {
add_portage_repository($_) for ( split( / /, $remote_overlay ) );
}
if ( $remove_layman_overlay and $remove_layman_overlay ne "" ) {
say "===== Removing overlays: $remove_remote_overlay =====";
system("layman -d $_") for ( split( / /, $remove_layman_overlay ) );
}
if ( $remove_remote_overlay and $remove_remote_overlay ne "" ) {
say "===== Removing overlays: $remove_remote_overlay =====";
system( "rm -rfv /etc/portage/" . $_ . ".conf" )
for ( split( / /, $remote_overlay ) );
}
system("mkdir -p /usr/portage/distfiles/git3-src"); system("mkdir -p /usr/portage/distfiles/git3-src");
unless($skip_portage_sync == 1){ unless ( $skip_portage_sync == 1 ) {
# sync portage and overlays # sync portage and overlays
system("layman -S"); system("layman -S");
if($webrsync == 1){ if ( $webrsync == 1 ) {
system("emerge-webrsync"); system("emerge-webrsync");
} else { }
else {
system("emerge --sync"); system("emerge --sync");
} }
} }
# preparing for MOAR automation # preparing for MOAR automation
qx|eselect profile set $profile|; qx|eselect profile set $profile|;
qx{ls /usr/portage/licenses -1 | xargs -0 > /etc/entropy/packages/license.accept}
; #HAHA
if ($use_equo && $entropy_repository eq "weekly" ) { if ( $use_equo && $entropy_repository eq "weekly" ) {
qx|equo repo disable sabayonlinux.org|; qx|equo repo disable sabayonlinux.org|;
qx|equo repo enable sabayon-weekly|; qx|equo repo enable sabayon-weekly|;
} elsif( $use_equo && $entropy_repository eq "testing") { }
elsif ( $use_equo && $entropy_repository eq "testing" ) {
qx|equo repo disable sabayon-weekly|; qx|equo repo disable sabayon-weekly|;
qx|equo repo enable sabayonlinux.org|; qx|equo repo enable sabayonlinux.org|;
qx|equo repo enable sabayon-limbo|; qx|equo repo enable sabayon-limbo|;
} }
if ($use_equo) { if ($use_equo) {
if ($enman_repositories and $enman_repositories ne "") {
my @enman_toadd=split(/ /,$enman_repositories); say "Devkit version:";
system("enman add $_") for @enman_toadd; system("equo s -vq app-misc/sabayon-devkit");
if ( $enman_repositories and $enman_repositories ne "" ) {
my @enman_toadd = split( / /, $enman_repositories );
safe_call("enman add $_") for @enman_toadd;
} }
if ( $remove_enman_repositories and $remove_enman_repositories ne "" ) {
my @enman_toremove = split( / /, $remove_enman_repositories );
system("enman remove $_") for @enman_toremove;
}
system("enman add $repository_name")
if ( $enman_add_self and $repository_name and $repository_name ne "" );
system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort; system("equo repo mirrorsort sabayonlinux.org") if $equo_mirrorsort;
system("equo up && equo u") system("equo up && equo u");
} }
system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf; system("cp -rf $make_conf /etc/portage/make.conf") if $make_conf;
qx|echo 'ACCEPT_LICENSE="*"' >> /etc/portage/make.conf|; #just plain evil
my @packages = @ARGV; my @packages = @ARGV;
my @injected_packages = ();
if ($build_injected_args) {
@injected_packages = split( / /, $build_injected_args );
}
if ($use_equo) { if ($use_equo) {
# best effort mask
if ($equo_masks) {
append_to_file( "/etc/entropy/packages/package.mask", $_ )
for ( split( / /, $equo_masks ) );
}
# best effort unmask
if ($equo_unmasks) {
append_to_file( "/etc/entropy/packages/package.unmask", $_ )
for ( split( / /, $equo_unmasks ) );
}
my @packages_deps; my @packages_deps;
my @Installed_Packages = qx/equo q list installed --quiet/; my @Installed_Packages = qx/equo q list installed --quiet/;
my @Available_Packages = available_packages(); my @Available_Packages = available_packages();
@@ -249,42 +372,66 @@ if ($use_equo) {
my %installed_packs = my %installed_packs =
map { $_ => 1 } @Installed_Packages; map { $_ => 1 } @Installed_Packages;
# Remove any already installed packages from the list of entropy packages to install in the build spec # Remove any already installed packages from the list of entropy packages to install in the build spec
@equo_install = grep { ! exists $installed_packs{$_} } @equo_install; @equo_install = grep { !exists $installed_packs{$_} } @equo_install;
foreach my $p (@packages) { foreach my $p (@packages) {
say "[$p] Getting the package dependencies which aren't already installed on the system.. "; say
push( @packages_deps, calculate_missing( $p , $dep_scan_depth,\@Installed_Packages,\@Available_Packages, $prune_virtuals) ) "[$p] Getting the package dependencies which aren't already installed on the system.. ";
if $equo_install_atoms; push(
@packages_deps,
calculate_missing(
$p, $dep_scan_depth,
\@Installed_Packages, \@Available_Packages,
$prune_virtuals
)
) if $equo_install_atoms;
push( @packages_deps, package_deps( $p, $dep_scan_depth, 0 ) ) push( @packages_deps, package_deps( $p, $dep_scan_depth, 0 ) )
if $equo_install_version; if $equo_install_version;
} }
@packages_deps = grep { defined() and length() } @packages_deps; #cleaning @packages_deps = grep { defined() and length() } @packages_deps; #cleaning
say "", "[install] Those dependencies will be installed with equo :", @packages_deps, ""; say "", "[install] Those dependencies will be installed with equo :",
@packages_deps, "";
if ($equo_split_install) { if ($equo_split_install) {
system("equo i --bdeps $_") for (@packages_deps,@equo_install); safe_call("equo i --bdeps $_")
if (@equo_remove > 0){ for ( @packages_deps, @equo_install )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff
if ( @equo_remove > 0 ) {
system("equo rm --nodeps $_") for (@equo_remove); system("equo rm --nodeps $_") for (@equo_remove);
} }
} }
else { else {
system("equo i --bdeps @packages_deps @equo_install") if ( @packages_deps > 0 or @equo_install > 0); safe_call("equo i --bdeps @packages_deps @equo_install")
system("equo rm --nodeps @equo_remove") if (@equo_remove > 0); if ( @packages_deps > 0 or @equo_install > 0 )
; ## bail out here, if installs fails. emerge will compile a LOT of stuff
system("equo rm --nodeps @equo_remove") if ( @equo_remove > 0 );
} }
} }
say "*** Repoman checks ***";
if ( $repoman_check == 1 ) {
say "*** QA checks for $_" && system("pushd \$(dirname \$(equery which $_ 2>/dev/null)); repoman; popd") for ( @packages, @injected_packages );
}
say "*** Ready to compile, finger crossed ***"; say "*** Ready to compile, finger crossed ***";
system("emerge --info"); #always give detailed information about the building environment, helpful to debug system("emerge --info")
; #always give detailed information about the building environment, helpful to debug
my $rt; my $rt;
if ( $emerge_remove and $emerge_remove ne "" ) {
system("emerge -C $_") for split( / /, $emerge_remove );
}
if ($emerge_split_install) { if ($emerge_split_install) {
for my $pack (@packages){ for my $pack (@packages) {
my $tmp_rt=system("emerge $emerge_defaults_args -j $jobs $pack"); say "\n" x 2, "==== Compiling $pack ====", "\n" x 2;
# $rt=$tmp_rt if ($? == -1 or $? & 127 or !$rt); # if one fails, the build should be considered failed! my $tmp_rt = system("emerge $emerge_defaults_args -j $jobs $pack");
# $rt=$tmp_rt if ($? == -1 or $? & 127 or !$rt); # if one fails, the build should be considered failed!
} }
$rt=0; #consider the build good anyway, like a "keep-going" $rt = 0; #consider the build good anyway, like a "keep-going"
} }
else { else {
$rt = system("emerge $emerge_defaults_args -j $jobs @packages"); $rt = system("emerge $emerge_defaults_args -j $jobs @packages");
@@ -292,9 +439,13 @@ else {
my $return = $rt >> 8; my $return = $rt >> 8;
# best effort -B
system("emerge $emerge_defaults_args -j $jobs -B $_") for (@injected_packages);
if ($preserved_rebuild) { if ($preserved_rebuild) {
system("emerge -j $jobs --buildpkg \@preserved-rebuild"); system("emerge -j $jobs --buildpkg \@preserved-rebuild");
system("revdep-rebuild");
} }
+11 -13
View File
@@ -9,7 +9,6 @@ OUTPUT_DIR="${OUTPUT_DIR:-$SAB_WORKSPACE/portage_artifacts/}"
LOCAL_OVERLAY="${LOCAL_OVERLAY:-$SAB_WORKSPACE/local_overlay}" LOCAL_OVERLAY="${LOCAL_OVERLAY:-$SAB_WORKSPACE/local_overlay}"
ENTROPY_REPOSITORY="${ENTROPY_REPOSITORY:-main}" # Can be weekly, main, testing ENTROPY_REPOSITORY="${ENTROPY_REPOSITORY:-main}" # Can be weekly, main, testing
DOCKER_OPTS="${DOCKER_OPTS:--ti --rm}" DOCKER_OPTS="${DOCKER_OPTS:--ti --rm}"
TEMPDIR=$(mktemp -d)
. /sbin/sabayondevkit-functions.sh . /sbin/sabayondevkit-functions.sh
@@ -40,23 +39,22 @@ docker_volumes=( -v "$OUTPUT_DIR:/usr/portage/packages" )
[ -z "$EQUO_MIRRORSORT" ] || docker_env+=(-e "EQUO_MIRRORSORT=$EQUO_MIRRORSORT") [ -z "$EQUO_MIRRORSORT" ] || docker_env+=(-e "EQUO_MIRRORSORT=$EQUO_MIRRORSORT")
[ -z "$WEBRSYNC" ] || docker_env+=(-e "WEBRSYNC=$WEBRSYNC") [ -z "$WEBRSYNC" ] || docker_env+=(-e "WEBRSYNC=$WEBRSYNC")
[ -z "$ENMAN_REPOSITORIES" ] || docker_env+=(-e "ENMAN_REPOSITORIES=$ENMAN_REPOSITORIES") [ -z "$ENMAN_REPOSITORIES" ] || docker_env+=(-e "ENMAN_REPOSITORIES=$ENMAN_REPOSITORIES")
[ -z "$REMOVE_ENMAN_REPOSITORIES" ] || docker_env+=(-e "REMOVE_ENMAN_REPOSITORIES=$REMOVE_ENMAN_REPOSITORIES")
[ -z "$DISTFILES" ] || docker_volumes+=(-v "$DISTFILES:/usr/portage/distfiles") [ -z "$DISTFILES" ] || docker_volumes+=(-v "$DISTFILES:/usr/portage/distfiles")
[ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages") [ -z "$ENTROPY_DOWNLOADED_PACKAGES" ] || docker_volumes+=(-v "$ENTROPY_DOWNLOADED_PACKAGES:/var/lib/entropy/client/packages")
[ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS") [ -z "$DISTCC_HOSTS" ] || docker_env+=(-e "DISTCC_HOSTS=$DISTCC_HOSTS")
[ -z "${PRUNE_VIRTUALS}" ] || docker_env+=(-e "PRUNE_VIRTUALS=$PRUNE_VIRTUALS") [ -z "${PRUNE_VIRTUALS}" ] || docker_env+=(-e "PRUNE_VIRTUALS=$PRUNE_VIRTUALS")
[ -z "$REPOSITORY_NAME" ] || docker_env+=(-e "REPOSITORY_NAME=$REPOSITORY_NAME")
[ -z "$ENMAN_ADD_SELF" ] || docker_env+=(-e "ENMAN_ADD_SELF=$ENMAN_ADD_SELF")
[ -z "$EQUO_MASKS" ] || docker_env+=(-e "EQUO_MASKS=$EQUO_MASKS")
[ -z "$EQUO_UNMASKS" ] || docker_env+=(-e "EQUO_UNMASKS=$EQUO_UNMASKS")
[ -z "$EMERGE_REMOVE" ] || docker_env+=(-e "EMERGE_REMOVE=$EMERGE_REMOVE")
[ -z "$REMOTE_OVERLAY" ] || docker_env+=(-e "REMOTE_OVERLAY=$REMOTE_OVERLAY")
[ -z "$REMOVE_LAYMAN_OVERLAY" ] || docker_env+=(-e "REMOVE_LAYMAN_OVERLAY=$REMOVE_LAYMAN_OVERLAY")
[ -z "$REMOVE_REMOTE_OVERLAY" ] || docker_env+=(-e "REMOVE_REMOTE_OVERLAY=$REMOVE_REMOTE_OVERLAY")
[ -z "$QA_CHECKS" ] || docker_env+=(-e "QA_CHECKS=$QA_CHECKS")
if [ -n "$REMOTE_OVERLAY" ]; then [ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/local_portage")
git clone "$REMOTE_OVERLAY" "$TEMPDIR"
LOCAL_OVERLAY=$TEMPDIR
fi
function cleanup {
rm -rf "$TEMPDIR"
}
trap cleanup EXIT
[ -d "$LOCAL_OVERLAY" ] && docker_volumes+=(-v "$LOCAL_OVERLAY:/usr/local/portage")
if [ -e $MAKE_CONF ]; then if [ -e $MAKE_CONF ]; then
echo "You specified a make.conf. I hope you know what are you doing" echo "You specified a make.conf. I hope you know what are you doing"
+8 -3
View File
@@ -54,19 +54,24 @@ mkdir -p /sabayon/artifacts
[[ -z "\${built_pkgs}" ]] && echo "ERROR: no tbz2s found" && exit 2 [[ -z "\${built_pkgs}" ]] && echo "ERROR: no tbz2s found" && exit 2
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
echo "=== Repository already exists, syncronizing ==="
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick \$repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "=== Repository is empty, intializing ==="
echo "Yes" | eit init --quick \$repo echo "Yes" | eit init --quick \$repo
eit push --quick --force
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "=== Injecting packages ==="
echo "Yes" | eit inject \${built_pkgs} || { echo "ouch unable to inject" && exit 3; } echo "Yes" | eit inject \${built_pkgs} || { echo "ouch unable to inject" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick echo "Yes Yes Yes" | eit commit --quick
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] &&\ echo "=== Pushing built packages locally ==="
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; }
eit push --quick --force eit push --quick --force
EOF EOF
+6 -1
View File
@@ -25,6 +25,8 @@ docker_volumes=(
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -40,12 +42,15 @@ repo="\${REPOSITORY:-default}"
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick $repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
eit clean --quick || { echo "ouch unable to remove" && exit 3; } eit clean --quick || { echo "ouch unable to remove" && exit 3; }
eit vacuum --quick || { echo "ouch unable to remove" && exit 3; } eit vacuum --quick || { echo "ouch unable to remove" && exit 3; }
+6 -2
View File
@@ -24,7 +24,8 @@ docker_volumes=(
-v "$createrepo:/sabayon/bin/create_repo.sh" -v "$createrepo:/sabayon/bin/create_repo.sh"
-v "$entropysrv:/etc/entropy/server.conf" -v "$entropysrv:/etc/entropy/server.conf"
-v "$PORTAGE_ARTIFACTS:/usr/portage/packages" ) -v "$PORTAGE_ARTIFACTS:/usr/portage/packages" )
[ -z "$PUBKEY" ] || docker_volumes+=(-v "$PUBKEY:/etc/entropy/mykeys/key.pub")
[ -z "$PRIVATEKEY" ] || docker_volumes+=(-v "$PRIVATEKEY:/etc/entropy/mykeys/private.key")
check_docker_requirements check_docker_requirements
@@ -40,12 +41,15 @@ repo="\${REPOSITORY:-default}"
if [ -d "/sabayon/artifacts/standard" ]; then if [ -d "/sabayon/artifacts/standard" ]; then
eit unlock \$repo || true eit unlock \$repo || true
eit pull --quick $repo || true eit pull --quick \$repo || true
#eit sync \$repo #eit sync \$repo
else else
echo "ouch no repository there" && exit 3; echo "ouch no repository there" && exit 3;
fi fi
[ -f "/etc/entropy/mykeys/key.pub" ] && [ -f "/etc/entropy/mykeys/private.key" ] && { ! eit key status \$repo; } && \
eit key import \$repo /etc/entropy/mykeys/private.key /etc/entropy/mykeys/key.pub && { eit key sign \$repo || true; } && { echo "=== Repository key imported successfully ==="; }
echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; } echo "Yes" | eit rm --from \$repo ${args[@]} || { echo "ouch unable to remove" && exit 3; }
echo "Yes Yes Yes" | eit commit --quick echo "Yes Yes Yes" | eit commit --quick
eit push --quick --force eit push --quick --force
+6
View File
@@ -0,0 +1,6 @@
#!/bin/bash
sudo bash << EOF
echo "Grabbing system informations, the url to share will happear in a minute"
(echo 'lspci'; lspci; echo 'network'; ifconfig -a; echo 'drivers'; lsmod; find /lib/modules; echo 'kernel'; uname -a) | pastebunz
EOF
Regular → Executable
View File
Regular → Executable
View File
Regular → Executable
View File
+4 -3
View File
@@ -11,9 +11,10 @@ die() { echo "$@" 1>&2 ; exit 1; }
build() { build() {
local SEARCH=$1 local SEARCH=$1
local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg} local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --verbose --oneshot --nospinner --noreplace --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg}
for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo | uniq); for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo | uniq);
do do
echo "Building $i"
emerge $EMERGE_DEFAULT_ARGS -o $i && \ emerge $EMERGE_DEFAULT_ARGS -o $i && \
emerge $EMERGE_DEFAULT_ARGS $i emerge $EMERGE_DEFAULT_ARGS $i
done done
@@ -21,11 +22,11 @@ for i in $(EIX_LIMIT=0 eix --only-names --pure-packages "$SEARCH/" | xargs echo
build_installed() { build_installed() {
local SEARCH=$1 local SEARCH=$1
local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --newuse --changed-use --update --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg} local EMERGE_DEFAULT_ARGS=${2:---accept-properties=-interactive --newuse --noreplace --changed-use --update --verbose --oneshot --nospinner --quiet-build=y --quiet-fail --fail-clean=y --complete-graph --buildpkg}
for i in $(EIX_LIMIT=0 eix -I --only-names --pure-packages "$SEARCH/" | xargs echo | uniq); for i in $(EIX_LIMIT=0 eix -I --only-names --pure-packages "$SEARCH/" | xargs echo | uniq);
do do
#emerge $EMERGE_DEFAULT_ARGS -o $i && \ echo "Building $i"
emerge $EMERGE_DEFAULT_ARGS $i emerge $EMERGE_DEFAULT_ARGS $i
done done
} }